//******************************************************************************
//  MSP430F4270 fE\tg
//
//  |[OSD16_Aϊʂ擾, `l7, oC|[ϊ
//@A-DϊʂEIA574ʂp\Rɏo(GNZŎM)
//  OSR = 256ADϊʂ24bitŎ擾
//******************************************************************************

#include "msp430x42x0.h"

void  t1ms(unsigned short dat);
void  TX_DAT(unsigned int j);

static const unsigned short tb[11]={
      3, 4, 3, 4, 3, 4, 3, 3, 4, 3, 4
};

long sum;
unsigned short AD_DAT[32];

void main(void)
{
  int i;
  long addat;

  WDTCTL = WDTPW + WDTHOLD;               // WDT̒~
  SCFQCTL = 94 - 1;                       // MCLK = 94 * ACLK * 2 = 6.16MHz, D = 2
  FLL_CTL0 = DCOPLUS + XCAP18PF;          // DCOPLUS = 1, eʕׂ18pF
  SCFI0 = FLLD_2 + FN_2;                  // D = 2, fDCOCLK =   2.2-17Mhz

  BTCTL = BT_ADLY_2000;                   // Basic Timer̃NbNACLK/256
  t1ms(5);                                // 5ms҂. FLL+肷̂҂

  P5DIR |= 0x10;                          // to RxD(EIA574)
  P1SEL |= 0x20;                          // P1.5 = TACLK

  SD16CTL = SD16VMIDON + SD16REFON + SD16SSEL_3 + SD16DIV_2 + SD16XDIV_2; //@ccc@
      // VMID I, 1.2V refI, SMCLK, /4, /16  fM = 6.16MHz / 4 / 16 = 96.256kHz
  t1ms(1);                                // 1ms҂FVref[q̃RfT[d҂@cccA
  SD16CTL &= ~SD16VMIDON;                 // VMID It@cccB

  SD16CCTL0 =  SD16BUF_0 + SD16DF + SD16LSBTOG + SD16OSR_256;  //@cccC
      // Int disable, oC|[2̕␔, LSBACC], OSR = 256
  SD16INCTL0 = SD16INTDLY_0 + SD16GAIN_1 + SD16INCH_7;  //@cccD
      // 4ڂ犄, PGA̗1, `l7(Z)

 do
 {
   SD16CCTL0 |= SD16SC;                   // ADϊJn@cccE
    sum = 0;
    for (i = 0; i < 32; i++)
    {
      while ((SD16CCTL0 & SD16IFG) == 0); // ϊI҂@cccF
      addat =(long) SD16MEM0 * 256;       // ϊʂ̏16bit256{addatϐց@cccG
      addat =addat + (SD16MEM0  & 0xff);  // ϊʂ̉16bitBit15`8NAaddatɑZ@cccH
      sum = sum + addat;                  // sumaddat̐ώZϐ@cccI
    }
    SD16CCTL0 &= ~SD16SC;                 // ADϊ~@cccJ

    sum = sum / 32;                       // ADϊʂ32̕ϒlƂĎ擾
    TX_DAT(sum >> 24);                    // ADϊʂEIA5744oCgó@cccK
    TX_DAT(sum >> 16);
    TX_DAT(sum >> 8);
    TX_DAT(sum);
 } while(1);
}


/***************************************
  1ms~datԑ҂ٰ
***************************************/
void t1ms(unsigned short dat)             // Basic Timer1ĝ5.4.2Ő
{
  unsigned short j;
  unsigned long i;

  i = 32.768 * dat - 22;                  // ACLK(32.768kHz)o߃JEgvZ
                                          // 22͎Ԓp(MCLK̒lŕς)
  do
  {
    j = BTCNT1;                           // j͉ʂ̃JE^l
    while(BTCNT1 == j);                   // BTCNT1JEgAbv܂ő҂
    i--;                                  // iPJEg
  }while (i != 0);                        // i=0(^CAbv)܂ŌJԂ
}

/******************************************************
// EIA574 Data transmit service routine
******************************************************/
void TX_DAT(unsigned int j)
{
  unsigned int i;                         // ϐ̐錾

  P5OUT |= 0x10;                          // TX = 0

  BTCNT1 = 0;                             // Timer_AJE^NA
  while (BTCNT1 < tb[0]);                 // 1҂
  BTCNT1 = 0;                             // Timer_AJE^NA
  P5OUT &= ~0x10;                         // TX = 1  X^[gErbg

  for (i = 0; i < 8; i++)                 // f[^̑M, D0
  {
    while (BTCNT1 < tb[i + 1]);           // 1҂
  BTCNT1 = 0;                             // Timer_AJE^NA
    if ((j & 0x1) == 0)
    {
      P5OUT &= ~0x10;                     // Mf[^0ȂTX = 1
    }
    else
    {
      P5OUT |= 0x10;                      // Mf[^1ȂTX = 0
    }
    j = j / 2;                            // Mf[^1rbgEVtg
  }
  while (BTCNT1 < tb[9]);                 // 1҂
  P5OUT |= 0x10;                          // TX = 0AXgbvErbg
  BTCNT1 = 0;                             // Timer_AJE^NA
  while (BTCNT1 < tb[10]);                // 1҂
}

